<?php

namespace Teknisa\MAN\Factories\OMClient;

use Zeedhi\Framework\DependencyInjection\InstanceManager;

// AOMClient stands for Abstract OM Client.
// OM is a Teknisa Software's app.
abstract class AOMClient {
    const DEFAULT_OM_SERVICE_URL      = "https://om.teknisa.com/backend/index.php/";

    const CLIENT_SECRET               = "lib5449996c21f780fe30badd6521931a5sac9"; 
    const CLIENT_ID                   = "cd7e85178153by60953518945f9hakt19a50a4";

    const REQUEST_TOKEN_ROUTE         = "/lib_requestToken";

    protected $omToken;
    protected $omServiceUrl;

    public function __construct($omServiceUrl = self::DEFAULT_OM_SERVICE_URL) {
        $this->omServiceUrl = $omServiceUrl;
    }

    public function getRequestToken() {
        return $this->omToken;
    }

    public function setRequestToken() {
        $url = $this->omServiceUrl; 
        $postData = array(
            'CLIENT_ID'     => self::CLIENT_ID,
            'CLIENT_SECRET' => self::CLIENT_SECRET 
        );
        
        $result = $this->callOMAPI($url, self::REQUEST_TOKEN_ROUTE, $postData, 'token');
        if(empty($result)) {
            throw new \Exception('Não foi possível obter o token de autenticação do OM.');
        }
        $this->omToken = $result[0];
    }

    protected function callOMAPI($url, $route, $postData, $dataset) {
        // Using Lib
        $util = InstanceManager::getInstance()->getService('libUtilities');
        return $util->callWebService($this->omToken, $route, $postData, $dataset, self::CLIENT_SECRET, $url);
    }
}